package com.bsoft.api.controller;

import com.bsoft.api.common.Result;
import com.bsoft.api.model.reqmodel.CodeAndPwd;
import com.bsoft.api.service.LoginService;
import com.bsoft.common.utils.HttpUtil;
import io.swagger.annotations.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import springfox.documentation.annotations.ApiIgnore;

import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping()
@Api(tags = {"登录"})
public class LoginController {

    @Autowired
    private LoginService loginServiceImpl;

    @PostMapping("login")
    @ApiOperation("登录")
    @ApiImplicitParams({
        @ApiImplicitParam(value = "登录名", name="loginName", required=true,paramType="query"),
        @ApiImplicitParam(value = "密码", name="password", required = true,paramType="query")})
    public Result<LoginService.LoginInfo> login(@RequestBody CodeAndPwd codeAndPwd,HttpServletRequest request){
        String ip = HttpUtil.getIP(request);
        LoginService.LoginInfo loginInfo = loginServiceImpl.login(
                codeAndPwd.getLoginName(),codeAndPwd.getPassword(),ip);
        return Result.success(loginInfo);
    }

    @GetMapping("token")
    @ApiOperation("刷新TOKEN")
    public Result<String> refresh(@ApiIgnore HttpServletRequest request){
        String oldToken = request.getHeader("Authorization");
        String token = loginServiceImpl.refreshToken(oldToken);
        return Result.success(token);
    }
}
